"""
Read csv files as provided by Swiss postal services containing road and zip.
Released into the public domain
2010 Andreas Stricker <andy@knitter.ch>
"""
import csv

def readPlzFile(filename):
    f = file(filename, 'r')
    sample = f.read(1024)
    f.seek(0)
    sniffer = csv.Sniffer()
    dialect = sniffer.sniff(sample)
    has_header = sniffer.has_header(sample)
    header = ('PLZ', 'Text')
    if has_header:
        reader = csv.DictReader(f, dialect=dialect)
    else:
        reader = csv.DictReader(f, fieldnames=header, dialect=dialect)
    result = []
    for item in reader:
        plz = unicode(item['PLZ'], 'utf-8')
        name = unicode(item['Text'], 'utf-8')
        if '/' in plz:
            plz = plz.split('/')
        result.append((plz, name))
    return result
